
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] gyroInstall] >= 0 } {
    interp expose {} gyroInstall
}

proc ::gyroInstall { name } {
    foreach rqst { "Connect" "GetConnectParams" "Disconnect" "CalibrateOffset" "SetAngle" "Log" "StopLog" "DataanglePosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} gyro$rqst $name
    }
}

interp hide {} gyroInstall




# Connect ----------------------------------------------------------

if { [lsearch [interp hidden] gyroConnect] >= 0 } {
    interp expose {} gyroConnect
}
if { [lsearch [interp hidden] gyroConnectFormatOutput] >= 0 } {
    interp expose {} gyroConnectFormatOutput
}

proc ::gyroConnect { name args } {
    set format {}
    lappend format [list string "device name" "/dev/ttyR4" ]

    return [ ::cs::rqstSend "${name}" "Connect" \
	"Connect to device" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::gyroConnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroConnect
interp hide {} gyroConnectFormatOutput





# GetConnectParams ----------------------------------------------------------

if { [lsearch [interp hidden] gyroGetConnectParams] >= 0 } {
    interp expose {} gyroGetConnectParams
}
if { [lsearch [interp hidden] gyroGetConnectParamsFormatOutput] >= 0 } {
    interp expose {} gyroGetConnectParamsFormatOutput
}

proc ::gyroGetConnectParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConnectParams" \
	"Serial link connection parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::gyroGetConnectParamsFormatOutput { list } {
    set format { {} status { } { device { } name } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroGetConnectParams
interp hide {} gyroGetConnectParamsFormatOutput





# Disconnect ----------------------------------------------------------

if { [lsearch [interp hidden] gyroDisconnect] >= 0 } {
    interp expose {} gyroDisconnect
}
if { [lsearch [interp hidden] gyroDisconnectFormatOutput] >= 0 } {
    interp expose {} gyroDisconnectFormatOutput
}

proc ::gyroDisconnect { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Disconnect" \
	"Disconnect from serial link" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::gyroDisconnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroDisconnect
interp hide {} gyroDisconnectFormatOutput





# CalibrateOffset ----------------------------------------------------------

if { [lsearch [interp hidden] gyroCalibrateOffset] >= 0 } {
    interp expose {} gyroCalibrateOffset
}
if { [lsearch [interp hidden] gyroCalibrateOffsetFormatOutput] >= 0 } {
    interp expose {} gyroCalibrateOffsetFormatOutput
}

proc ::gyroCalibrateOffset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "CalibrateOffset" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::gyroCalibrateOffsetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroCalibrateOffset
interp hide {} gyroCalibrateOffsetFormatOutput





# SetAngle ----------------------------------------------------------

if { [lsearch [interp hidden] gyroSetAngle] >= 0 } {
    interp expose {} gyroSetAngle
}
if { [lsearch [interp hidden] gyroSetAngleFormatOutput] >= 0 } {
    interp expose {} gyroSetAngleFormatOutput
}

proc ::gyroSetAngle { name args } {
    set format {}
    lappend format [list double "angleInit" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetAngle" \
	"Init angle value" \
	"double angleInit\n" \
	1 \
	$format \
	$args ]
}


proc ::gyroSetAngleFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroSetAngle
interp hide {} gyroSetAngleFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] gyroLog] >= 0 } {
    interp expose {} gyroLog
}
if { [lsearch [interp hidden] gyroLogFormatOutput] >= 0 } {
    interp expose {} gyroLogFormatOutput
}

proc ::gyroLog { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::gyroLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroLog
interp hide {} gyroLogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] gyroStopLog] >= 0 } {
    interp expose {} gyroStopLog
}
if { [lsearch [interp hidden] gyroStopLogFormatOutput] >= 0 } {
    interp expose {} gyroStopLogFormatOutput
}

proc ::gyroStopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::gyroStopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroStopLog
interp hide {} gyroStopLogFormatOutput





# Dataangle ----------------------------------------------------------

if { [lsearch [interp hidden] gyroDataanglePosterRead] >= 0 } {
    interp expose {} gyroDataanglePosterRead
}
if { [lsearch [interp hidden] gyroDataanglePosterFormatOutput] >= 0 } {
    interp expose {} gyroDataanglePosterFormatOutput
}

proc ::gyroDataanglePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Dataangle" \
	"GYRO_YAW\n| double yaw\n" \
	$args ]
}


proc ::gyroDataanglePosterFormatOutput { list } {
    set format { {} status { } { angle { } yaw } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} gyroDataanglePosterRead
interp hide {} gyroDataanglePosterFormatOutput


